"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const authz_constants_1 = require("./authz.constants");
const casbin = require("casbin");
const common_2 = require("@nestjs/common");
const types_1 = require("./types");
let AuthZGuard = class AuthZGuard {
    constructor(reflector, enforcer, options) {
        this.reflector = reflector;
        this.enforcer = enforcer;
        this.options = options;
    }
    canActivate(context) {
        try {
            const permissions = this.reflector.get(authz_constants_1.PERMISSIONS_METADATA, context.getHandler());
            if (!permissions) {
                return true;
            }
            const username = this.options.usernameFromContext(context);
            if (!username) {
                throw new common_2.UnauthorizedException();
            }
            const hasPermission = (user, permission) => {
                const { possession, resource, action } = permission;
                const poss = [];
                if (possession === types_1.AuthPossession.OWN_ANY) {
                    poss.push(types_1.AuthPossession.ANY, types_1.AuthPossession.OWN);
                }
                else {
                    poss.push(possession);
                }
                return poss.some(p => {
                    if (p === types_1.AuthPossession.OWN) {
                        return permission.isOwn(context);
                    }
                    else {
                        return this.enforcer.enforce(user, resource, `${action}:${p}`);
                    }
                });
            };
            const result = permissions.every(permission => hasPermission(username, permission));
            return result;
        }
        catch (e) {
            throw e;
        }
    }
};
AuthZGuard = __decorate([
    common_1.Injectable(),
    __param(1, common_1.Inject(authz_constants_1.AUTHZ_ENFORCER)),
    __param(2, common_1.Inject(authz_constants_1.AUTHZ_MODULE_OPTIONS)),
    __metadata("design:paramtypes", [core_1.Reflector, casbin.Enforcer, Object])
], AuthZGuard);
exports.AuthZGuard = AuthZGuard;
