import * as casbin from 'casbin';
export declare class AuthZManagementService {
    private readonly enforcer;
    constructor(enforcer: casbin.Enforcer);
    getAllSubjects(): string[];
    getAllNamedSubjects(ptype: string): string[];
    getAllObjects(): string[];
    getAllNamedObjects(ptype: string): string[];
    getAllActions(): string[];
    getAllNamedActions(ptype: string): string[];
    getAllRoles(): string[];
    getAllNamedRoles(ptype: string): string[];
    getPolicy(): string[][];
    getFilteredPolicy(fieldIndex: number, ...fieldValues: string[]): string[][];
    getNamedPolicy(ptype: string): string[][];
    getFilteredNamedPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): string[][];
    getGroupingPolicy(): string[][];
    getFilteredGroupingPolicy(fieldIndex: number, ...fieldValues: string[]): string[][];
    getNamedGroupingPolicy(ptype: string): string[][];
    getFilteredNamedGroupingPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): string[][];
    hasPolicy(...params: string[]): boolean;
    hasNamedPolicy(ptype: string, ...params: string[]): boolean;
    addPolicy(...params: string[]): Promise<boolean>;
    addNamedPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    removePolicy(...params: string[]): Promise<boolean>;
    removeFilteredPolicy(fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    removeNamedPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    removeFilteredNamedPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    hasGroupingPolicy(...params: string[]): boolean;
    hasNamedGroupingPolicy(ptype: string, ...params: string[]): boolean;
    addGroupingPolicy(...params: string[]): Promise<boolean>;
    addNamedGroupingPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    removeGroupingPolicy(...params: string[]): Promise<boolean>;
    removeFilteredGroupingPolicy(fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    removeNamedGroupingPolicy(ptype: string, ...params: string[]): Promise<boolean>;
    removeFilteredNamedGroupingPolicy(ptype: string, fieldIndex: number, ...fieldValues: string[]): Promise<boolean>;
    addFunction(name: string, func: any): void;
}
